import type { returnType } from '../_utils/props';
import type { DefineComponent, PropType, ComputedRef, CSSProperties, ComponentOptionsMixin, VNodeProps, AllowedComponentProps, ComponentCustomProps, ExtractPropTypes } from 'vue';
import type { Install } from '../_utils/withInstall';
import las from "./src/laside";
declare const DkLaside: Install<DefineComponent<{
    readonly width: returnType<PropType<string | number>, string | number | null>;
    readonly height: returnType<PropType<string | number>, string | number | null>;
    readonly padding: returnType<PropType<string | number>, string | number | null>;
}, {
    style_List: ComputedRef<CSSProperties>;
}, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {}, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
    readonly width: returnType<PropType<string | number>, string | number | null>;
    readonly height: returnType<PropType<string | number>, string | number | null>;
    readonly padding: returnType<PropType<string | number>, string | number | null>;
}>>, {
    readonly width: string | number;
    readonly height: string | number;
    readonly padding: string | number;
}, {}>>;
export type lasInstance = InstanceType<typeof las>;
export { DkLaside };
export default DkLaside;
