import { defineComponent as ge, useSlots as ye, shallowRef as q, computed as G, ref as c, reactive as b, watch as J, resolveComponent as me, openBlock as s, createElementBlock as p, normalizeClass as u, unref as n, normalizeStyle as P, renderSlot as w, createBlock as y, createCommentVNode as a, toDisplayString as d, createElementVNode as _, withDirectives as Q, mergeProps as W, withKeys as ke, vModelDynamic as xe, vShow as ve, nextTick as Pe } from "vue";
import { dkInputProps as we } from "./index3.js";
import { inputEmits as _e } from "./index4.js";
import { getInput as Ie, setPropData as Ce, verifyInputType as Te, setData as Se, getNull as L, getBooleanAnd as X, getValue as be, getPendValue as Le } from "../../_hooks/get-input/index.js";
import { getReturn as Ve } from "../../_hooks/public/get-return/index.js";
import "../../_icon/index.js";
const Ae = { key: 1 }, $e = {
  key: 0,
  class: "dk-input_label-text"
}, De = {
  key: 1,
  class: "dk-input_prefix"
}, ze = ["type", "onKeydown"], Ee = {
  key: 2,
  class: "dk-input_length"
}, Re = {
  key: 3,
  class: "dk-input_length"
}, Be = {
  key: 4,
  class: "dk-input_suffix"
}, Ke = { key: 1 }, Ne = ["type"], He = {
  key: 0,
  class: "dk-input_textarea_length"
}, Fe = {
  key: 1,
  class: "dk-input_length"
}, Je = /* @__PURE__ */ ge({
  __name: "input",
  props: we,
  emits: _e,
  setup(Y, { emit: h }) {
    const i = Y, I = ye(), V = q(), A = q(), k = G(() => V.value || A.value), { classList: $, styleList: D, wrapperClassList: z, innerClassList: Z, pendStyleList: E } = Ie(i), x = c(i.modelValue), R = c(!1), B = c(!1), t = Ce(i), m = c(i.modelValue);
    let f = !1, g = c(Te(t.typeProp, f));
    const ee = (e = "") => {
      let o = "";
      return t.maxlengthProp && t.minlengthProp ? o = `${t.minlengthProp}/${t.maxlengthProp}` : t.maxlengthProp ? o = `${e.toString().length}/${t.maxlengthProp}` : t.minlengthProp && (o = `${t.minlengthProp}`), o;
    }, l = Se(t, I, g.value), te = G(() => L(m.value));
    let C = ee();
    const K = b({
      isPrependText: X([
        !I.prepend,
        L(t.prependText),
        !l.isPrependIcon
      ]),
      isAppendText: X([
        L(t.appendText),
        !I.append,
        !l.isAppendIcon
      ])
    }), ne = ["dk-input_prepend", "dk-input_pend"], oe = ["dk-input_append", "dk-input_pend"], T = c(0);
    J(
      () => i.modelValue,
      () => {
        m.value = be(
          i.modelValue,
          t.prependText,
          t.prependIcon,
          t.appendText,
          t.appendIcon
        ), x.value = m.value;
      }
    ), J(
      () => m.value,
      (e) => {
        const o = e.toString().length;
        if (t.maxlengthProp && (C = `${o}/${t.maxlengthProp}`), U().autosize) {
          const r = k.value;
          r.style.height = "auto", r.style.height = `${r.scrollHeight + 2}px`;
        }
        l.showLength && (T.value = o), t.typeProp === "number" ? h("update:modelValue", Number(e)) : h(
          "update:modelValue",
          Le(
            e,
            t.prependText,
            t.prependIcon,
            t.appendText,
            t.appendIcon
          )
        );
      }
    );
    const N = (e) => {
      const o = e.target;
      m.value = o.value;
    }, se = () => ["dk-input_prefix-icon", typeof t.prefixIcon == "boolean" ? "dk-icon-search" : t.prefixIcon], le = () => ["dk-input_suffix-icon", typeof t.suffixIcon == "boolean" ? "dk-icon-search" : t.suffixIcon], ae = () => {
      x.value = "", h("update:modelValue", ""), H();
    }, H = async () => {
      var e;
      await Pe(), (e = k.value) == null || e.focus();
    };
    let F = c("IconPasswordSee");
    const pe = () => {
      var e, o;
      f = !f, F.value = f ? "IconPasswordShow" : "IconPasswordSee", g.value = f ? "text" : "password", f ? (e = k.value) == null || e.setAttribute("type", "text") : (o = k.value) == null || o.setAttribute("type", "password"), H();
    }, re = () => ["dk-input_password-icon"], M = (e) => {
      R.value = !0, h("focus", e);
    }, O = (e) => {
      R.value = !1, h("blur", e);
    }, { getRun: S } = Ve(), ie = (e) => {
      S(i.onAppendClick, e);
    }, ue = (e) => {
      S(i.onPrependClick, e);
    }, ce = (e) => {
      if (e.which === 13) {
        const o = e.target;
        S(i.onEnter, o.value);
      }
    }, U = () => {
      let e = 1;
      const o = g.value === "textarea", r = t.autosizeProp, v = +t.rowsProp, fe = v > 0;
      return o && fe && (e = v), {
        row: e,
        autosize: o && r
      };
    }, j = (e) => {
      const o = e.target;
      h("change", o.value);
    }, de = b({
      class: Z.value,
      placeholder: t.placeholder,
      oninput: N,
      disabled: t.disabledProp,
      inputmode: l.inputmode,
      onfocus: M,
      onblur: O,
      onChange: j,
      maxlength: t.maxlengthProp,
      minlength: t.minlengthProp,
      readonly: t.readonlyProp
    }), he = b({
      class: z.value,
      type: g.value,
      placeholder: t.placeholder,
      onInput: N,
      onfocus: M,
      onblur: O,
      onChange: j,
      disabled: t.disabledProp,
      maxlength: t.maxlengthProp,
      minlength: t.minlengthProp,
      autosize: t.autosizeProp,
      rows: U().row,
      readonly: t.readonlyProp
    });
    return (e, o) => {
      const r = me("dk-icon");
      return e.type !== "textarea" ? (s(), p("div", {
        key: 0,
        class: u([n($), "dk-input"]),
        style: P(n(D))
      }, [
        !B.value && n(l).isPrepend ? (s(), p("div", {
          key: 0,
          class: u(ne),
          style: P(n(E))
        }, [
          w(e.$slots, "prepend"),
          n(l).isPrependIcon ? (s(), y(r, {
            key: 0,
            icon: e.prependIcon,
            onClick: ue
          }, null, 8, ["icon"])) : a("", !0),
          K.isPrependText ? (s(), p("span", Ae, d(e.prependText), 1)) : a("", !0)
        ], 4)) : a("", !0),
        _("div", {
          class: u(n(z))
        }, [
          n(l).labelText ? (s(), p("div", $e, [
            _("span", null, d(n(l).labelText), 1)
          ])) : a("", !0),
          n(l).isPrefix ? (s(), p("span", De, [
            w(e.$slots, "prefix"),
            n(l).isPrefixIcon ? (s(), y(r, {
              key: 0,
              class: u(se),
              icon: e.prefixIcon,
              size: "19px"
            }, null, 8, ["icon"])) : a("", !0)
          ])) : a("", !0),
          Q(_("input", W({
            ref_key: "input",
            ref: V,
            "onUpdate:modelValue": o[0] || (o[0] = (v) => x.value = v),
            type: n(g)
          }, de, {
            onKeydown: ke(ce, ["enter"])
          }), null, 16, ze), [
            [xe, x.value]
          ]),
          n(l).isLength ? (s(), p("span", Ee, d(n(C)), 1)) : a("", !0),
          e.showLength ? (s(), p("span", Re, d(T.value), 1)) : a("", !0),
          n(l).isSuffix ? (s(), p("div", Be, [
            w(e.$slots, "suffix"),
            n(l).isSuffixIcon ? (s(), y(r, {
              key: 0,
              class: u(le),
              icon: e.suffixIcon
            }, null, 8, ["icon"])) : a("", !0)
          ])) : a("", !0),
          n(l).isClear ? Q((s(), y(r, {
            key: 5,
            class: "dk-input-clearable",
            icon: "IconShanchu1",
            onClick: ae
          }, null, 512)), [
            [ve, te.value]
          ]) : a("", !0),
          n(l).isShowPassword ? (s(), y(r, {
            key: 6,
            class: u(re),
            icon: n(F),
            onClick: pe
          }, null, 8, ["icon"])) : a("", !0)
        ], 2),
        !B.value && n(l).isAppend ? (s(), p("div", {
          key: 1,
          class: u(oe),
          style: P(n(E))
        }, [
          w(e.$slots, "append"),
          n(l).isAppendIcon ? (s(), y(r, {
            key: 0,
            icon: e.appendIcon,
            onClick: ie
          }, null, 8, ["icon"])) : a("", !0),
          K.isAppendText ? (s(), p("span", Ke, d(e.appendText), 1)) : a("", !0)
        ], 4)) : a("", !0)
      ], 6)) : (s(), p("div", {
        key: 1,
        class: u(n($)),
        style: P(n(D))
      }, [
        _("textarea", W({
          ref_key: "textarea",
          ref: A,
          type: n(g)
        }, he), null, 16, Ne),
        n(l).isLength ? (s(), p("span", He, d(n(C)), 1)) : a("", !0),
        e.showLength ? (s(), p("span", Fe, d(T.value), 1)) : a("", !0)
      ], 6));
    };
  }
});
export {
  Je as default
};
