import type { returnType } from '../_utils/props';
import type { DefineComponent, PropType, Ref, ComponentOptionsMixin, VNodeProps, AllowedComponentProps, ComponentCustomProps, ExtractPropTypes } from 'vue';
import type { Install } from '../_utils/withInstall';
import radioGroup from "./src/radioGroup";
export declare const DkRadioGroup: Install<DefineComponent<{
    modelValue: returnType<PropType<string>, string | null>;
}, {
    slotList: any;
    handleChange: (name: string) => void;
    checkValue: Ref<string>;
}, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, ("update:modelValue" | "change")[], "update:modelValue" | "change", VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
    modelValue: returnType<PropType<string>, string | null>;
}>> & {
    "onUpdate:modelValue"?: ((...args: any[]) => any) | undefined;
    onChange?: ((...args: any[]) => any) | undefined;
}, {
    modelValue: string;
}, {}>>;
export type radioGroupInstance = InstanceType<typeof radioGroup>;
