import type { ContainerDirection } from './src/interface';
import type { returnType } from '../_utils/props';
import type { DefineComponent, PropType, ComputedRef, ComponentOptionsMixin, VNodeProps, AllowedComponentProps, ComponentCustomProps, ExtractPropTypes } from 'vue';
import type { Install } from '../_utils/withInstall';
import Container from "./src/container";
export declare const DkContainer: Install<DefineComponent<{
    readonly direction: returnType<PropType<ContainerDirection>, ContainerDirection | null>;
}, {
    isVertical: ComputedRef<boolean>;
}, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {}, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
    readonly direction: returnType<PropType<ContainerDirection>, ContainerDirection | null>;
}>>, {
    readonly direction: ContainerDirection;
}, {}>>;
export type ContainerInstance = InstanceType<typeof Container>;
export default DkContainer;
