import type { returnType } from '../_utils/props';
import type { DefineComponent, PropType, ComputedRef, CSSProperties, ComponentOptionsMixin, VNodeProps, AllowedComponentProps, ComponentCustomProps, ExtractPropTypes } from 'vue';
import type { Install } from '../_utils/withInstall';
import footer from "./src/footer";
export declare const DkFooter: Install<DefineComponent<{
    readonly height: returnType<PropType<string | number>, string | number | null>;
    readonly padding: returnType<PropType<string | number>, string | number | null>;
}, {
    style_List: ComputedRef<CSSProperties>;
}, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {}, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
    readonly height: returnType<PropType<string | number>, string | number | null>;
    readonly padding: returnType<PropType<string | number>, string | number | null>;
}>>, {
    readonly height: string | number;
    readonly padding: string | number;
}, {}>>;
export type footerInstance = InstanceType<typeof footer>;
export default DkFooter;
